#pragma once

#include "preferences.h"
#include "afxwin.h"
#include "FontPreviewCombo.h"

// CPPgWindow dialog

class CPPgWindow : public CPropertyPage
{
	DECLARE_DYNAMIC(CPPgWindow)

public:
	CPPgWindow();
	virtual ~CPPgWindow();

	void SetPrefs(CPreferences* in_prefs) {	app_prefs = in_prefs; }

// Dialog Data
	enum { IDD = IDD_PPG_WINDOW };
protected:
	CPreferences *app_prefs;
	CFontPreviewCombo	m_FontCombo;
	CComboBox				m_FontSize;

	bool m_bModified;
	void SetModified(BOOL bChanged = TRUE)
	{
		m_bModified = bChanged;
		CPropertyPage::SetModified(bChanged);
	}
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	void LoadSettings(void);
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	void Localize(void);
	virtual BOOL OnApply();
	afx_msg void OnEnChangeStartMin()				{ SetModified(); }
	afx_msg void OnBnClickedMintray()				{ SetModified(); }
	afx_msg void OnBnClickedExit()					{ SetModified(); }
	afx_msg void OnBnClickedBringtoforeground()		{ SetModified(); }
	afx_msg void OnBnClickedCbTbnClosetotray()  	{ SetModified(); }
	afx_msg void OnCbnSelchangeUsedFont()  			{ SetModified(); }
	afx_msg void OnCbnSelchangeUsedfontsize()		{ SetModified(); };
	afx_msg void OnBnClickedEd2kfix();
	afx_msg void OnBnClickedAutoTakeED2KLinks()		{ SetModified(); }
	afx_msg void OnBnClickedShowRateOnTitle()		{ SetModified(); }
};
