//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// StatisticsDlg.cpp : implementation file
//
#include "stdafx.h"
#include "emule.h"
#include "StatisticsDlg.h"
#include "uploadqueue.h"
#include "otherfunctions.h"
#include "WebServer.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

bool g_bUseNewStyle = false;

typedef enum
{
	STATS_UNKNOWN = 0,
	STATS_TRANSFER = 100,
	STATS_TRANSFER_SESSIONRATIO = 101,
	STATS_TRANSFER_UPLOADS = 102,
	STATS_TRANSFER_UPLOADS_TRANSFERRED = 103,
	STATS_TRANSFER_UPLOADS_ACTIVE = 104,
	STATS_TRANSFER_UPLOADS_WAITING = 105,
	STATS_TRANSFER_UPLOADS_SUCCEEDED = 106,
	STATS_TRANSFER_UPLOADS_FAILED = 107,
	STATS_TRANSFER_UPLOADS_AVGTIME = 108,
	STATS_TRANSFER_DOWNLOADS = 200,
	STATS_TRANSFER_DOWNLOADS_TRANSFERRED = 201,
	STATS_TRANSFER_DOWNLOADS_SOURCES = 202,
	STATS_TRANSFER_DOWNLOADS_ACTIVE = 203,
	STATS_TRANSFER_DOWNLOADS_UDPSEARCH = 204,
	STATS_CONNECTION = 300,
	STATS_CONNECTION_AVGDOWNLOADRATE = 301,
	STATS_CONNECTION_AVGUPLOADRATE = 302,
	STATS_CONNECTION_MAXDOWNLOADRATEAVG = 303,
	STATS_CONNECTION_MAXDOWNLOADRATESESSION = 304,
	STATS_CONNECTION_RECONNECTED = 305,
	STATS_CONNECTION_SINCEFIRSTTRANSFER = 306,
	STATS_CONNECTION_CONNECTEDSINCE = 307,
	STATS_CONNECTION_ACTIVE = 308,
	STATS_CONNECTION_MAXTIME = 309,
	STATS_CONNECTION_AVERAGE = 310,
	STATS_CONNECTION_MAXIMUM = 311,
	STATS_CLIENTS = 400,
	STATS_CLIENTS_EMULE = 401,
	STATS_CLIENTS_EMULE_1 = 402,
	STATS_CLIENTS_EMULE_2 = 403,
	STATS_CLIENTS_EMULE_3 = 404,
	STATS_CLIENTS_CDONKEY = 405,
	//Cax2 - keep them in enum order...
	STATS_CLIENTS_EMULE_OTHER=406,
	//STATS_CLIENTS_CDONKEY_1 = 406,
	STATS_CLIENTS_CDONKEY_2 = 407,
	STATS_CLIENTS_CDONKEY_3 = 408,
	STATS_CLIENTS_EDONKEYHYBRID = 409,
	STATS_CLIENTS_EDONKEYHYBRID_1 = 410,
	STATS_CLIENTS_EDONKEYHYBRID_2 = 411,
	STATS_CLIENTS_EDONKEYHYBRID_3 = 412,
	STATS_CLIENTS_EDONKEY = 413,
	STATS_CLIENTS_EDONKEY_1 = 414,
	STATS_CLIENTS_EDONKEY_2 = 415,
	STATS_CLIENTS_EDONKEY_3 = 416,
	STATS_CLIENTS_OLDMLDONKEY = 417,
	STATS_CLIENTS_OLDMLDONKEY_1 = 418,
	STATS_CLIENTS_OLDMLDONKEY_2 = 419,
	STATS_CLIENTS_OLDMLDONKEY_3 = 420,
	STATS_CLIENTS_OLDEMULE = 421,
	STATS_CLIENTS_OLDEMULE_1 = 422,
	STATS_CLIENTS_OLDEMULE_2 = 423,
	STATS_CLIENTS_OLDEMULE_3 = 424,
	STATS_CLIENTS_UNKNOWN = 425,
	STATS_QUEUE = 500,
	STATS_QUEUE_TRANSFERRING = 501,
	STATS_QUEUE_INQUEUE = 502,
	STATS_QUEUE_ASKING = 503,
	STATS_QUEUE_CONNECTING = 504,
	STATS_QUEUE_THRUSERVER = 505,
	STATS_QUEUE_GOTHASH = 506,
	STATS_QUEUE_NONEEDEDPARTS = 507,
	STATS_QUEUE_TOOMANYCONS = 508,
	STATS_QUEUE_TWOLOWIDS = 509,
	STATS_QUEUE_BLOCKED = 510,
	STATS_QUEUE_PROBLEM = 511,
	STATS_QUEUE_UNKNOWN = 512,
	STATS_SERVERS = 600,
	STATS_SERVERS_WORKING = 601,
	STATS_SERVERS_BAD = 602,
	STATS_SERVERS_TOTAL = 603,
	STATS_SERVERS_DELETED = 604,
	STATS_SERVERS_WORKINGUSERS = 605,
	STATS_SERVERS_WORKINGFILES = 606,
	STATS_SERVERS_TOTALUSERS = 607,
	STATS_SERVERS_TOTALFILES = 608,
	STATS_SERVERS_ONSERVER = 609,
	STATS_SHAREDFILES = 700,
	STATS_SHAREDFILES_TOTAL = 701,
	STATS_SHAREDFILES_TOTALSIZE = 702,
	STATS_SHAREDFILES_AVGSIZE = 703,
	STATS_TOTALDOWN = 800,
	STATS_TOTALDOWN_TOTAL = 801,
	STATS_TOTALDOWN_TOTALSIZE = 802,
	STATS_TOTALDOWN_DOWNLOADED = 803,
	STATS_TOTALDOWN_LEFT = 804,
	STATS_TOTALDOWN_NEEDSPACE = 805,
	STATS_TOTALDOWN_SPACELEFT = 806
} StatsDataEntry;

CStatisticsData::~CStatisticsData()
{
	EMULE_TRY
	for (int i=0;i < m_DataList.GetCount();i++)
	{
		if ( m_DataList[i] )
		{
			delete m_DataList[i];
		}
	}
	m_DataList.RemoveAll();
	EMULE_CATCH
}

CStatisticsData::CDataEntry::CDataEntry(unsigned int nID, CString sTitle, CDataEntry* pParent)
{
	try
	{
		m_nID = nID;
		m_sTitle = sTitle;
		m_pParent = pParent;
		m_pTopItem = m_pSubItem = NULL;
		m_hItem = NULL;
		if(!pParent)
			m_nLevel = 0;
		else
			m_nLevel = pParent->m_nLevel + 1;
	}
	catch(...)
	{
		TRACE("Exception in CDataEntry constructor\n");
	}
}

COptionTreeItem* CStatisticsData::CDataEntry::GetItem()
{
	if(!m_nLevel)
		return m_pTopItem;
	else
		return (COptionTreeItem*)m_pSubItem;
}

CStatisticsData::CDataEntry* CStatisticsData::CDataEntry::GetParent(unsigned int nParentLevel)
{
	try
	{
		if(nParentLevel >= m_nLevel)
			return this;
		else
			return m_pParent->GetParent(nParentLevel);
	}
	catch(...)
	{
		TRACE("Exception in CDataEntry GetParent\n");
		return NULL;
	}
}

void CStatisticsData::CDataEntry::Expand(bool bExpand)
{
	try
	{
		if(!m_nLevel)
			m_pTopItem->Expand(bExpand);
		else
			m_pSubItem->Expand(bExpand);
	}
	catch(...)
	{
		TRACE("Exception in CDataEntry Expand\n");
	}
}

bool CStatisticsData::CDataEntry::IsExpanded()
{
	try
	{
		if(!m_nLevel)
			return m_pTopItem->IsExpanded();
		else
			return m_pSubItem->IsExpanded();
	}
	catch(...)
	{
		TRACE("Exception in CDataEntry Expand\n");
	}
	return false;
}

void CStatisticsData::AddEntry(unsigned int nID, CString sTitle, unsigned int nLevel)
{
	EMULE_TRY

	static CDataEntry* pLastData = NULL;

	CDataEntry* pData;
	if(nLevel == 0 || pLastData == NULL)
		pData = new CDataEntry(nID, sTitle, NULL);
	else
		pData = new CDataEntry(nID, sTitle, pLastData->GetParent(nLevel - 1));

	pLastData = pData;

	if(g_bUseNewStyle)
	{
		if(pData->m_nLevel == 0)
		{
			pData->m_pTopItem = m_ctrlStatsList.InsertItem(new COptionTreeItem);
			pData->m_pTopItem->SetLabelText(sTitle);
		}
		else
		{
			pData->m_pSubItem = (COptionTreeItemStatic*)m_ctrlStatsList.InsertItem(new COptionTreeItemStatic, pData->GetParent(nLevel - 1)->GetItem());
			pData->m_pSubItem->SetLabelText(sTitle);
			if(pData->m_pSubItem->CreateStaticItem(0))
				pData->m_pSubItem->SetTextColor(RGB(0,45,126));
		}
	}
	else
	{
		if(pData->m_nLevel == 0)
			pData->m_hItem = stattree.InsertItem(sTitle);
		else
			pData->m_hItem = stattree.InsertItem(sTitle, pData->GetParent(nLevel - 1)->m_hItem);
	}

	m_DataList.Add(pData);

	EMULE_CATCH2
}

CStatisticsData::CDataEntry* CStatisticsData::FindItem(unsigned int nID)
{
	EMULE_TRY

	for(int i = 0; i < m_DataList.GetCount(); i++)
	{
		if(m_DataList[i]->m_nID == nID)
			return m_DataList[i];
	}

	EMULE_CATCH2

	return NULL;
}

void CStatisticsData::SetTitle(unsigned int nID, CString sTitle)
{
	EMULE_TRY

	CDataEntry *pData = FindItem(nID);
	if(pData)
	{
		pData->m_sTitle = sTitle;
		if(g_bUseNewStyle)
			pData->GetItem()->SetLabelText(sTitle);
		else
			stattree.SetItemText(pData->m_hItem, pData->m_sTitle);
	}

	EMULE_CATCH2
}

void CStatisticsData::SetStatic(unsigned int nID, CString sStatic)
{
	EMULE_TRY

	CDataEntry *pData = FindItem(nID);
	if(pData)
	{
		pData->m_sValue = sStatic;
		if(g_bUseNewStyle)
			((COptionTreeItemStatic*)pData->GetItem())->SetStaticText(sStatic);
		else
			stattree.SetItemText(pData->m_hItem, pData->m_sTitle + pData->m_sValue);
	}

	EMULE_CATCH2
}

void CStatisticsData::Expand(unsigned int nID, bool bExpand)
{
	EMULE_TRY

	CDataEntry *pData = FindItem(nID);
	if(pData)
	{
		if(g_bUseNewStyle)
			pData->Expand(bExpand);
		else
			stattree.Expand(pData->m_hItem, bExpand ? TVE_EXPAND : TVE_COLLAPSE);
	}

	EMULE_CATCH2
}

bool CStatisticsData::IsExpanded(unsigned int nID)
{
	EMULE_TRY

	CDataEntry *pData = FindItem(nID);
	if(pData)
	{
		if(g_bUseNewStyle)
			return pData->IsExpanded();
		else
			return true;	// is there possibility to see when we're expanded?
	}

	EMULE_CATCH2

	return false;
}

void CStatisticsData::SetValue(unsigned int nID, CString sValue, bool bReverse)
{
	EMULE_TRY

	if(g_bUseNewStyle)
	{
		int iPos;
		if(bReverse)
			iPos = sValue.ReverseFind(':');
		else
			iPos = sValue.Find(':', 0);
		CString strValue = sValue.Right(sValue.GetLength()-iPos-1);
		CString strLabel = sValue.Left(iPos > 0 ? iPos : 0);
		if(strLabel.GetLength() > 0)
		{
			SetTitle(nID, strLabel);
			SetStatic(nID, strValue);
		}
		else
			SetTitle(nID, strValue);
	}
	else
		SetTitle(nID, sValue);

	EMULE_CATCH2
}

void CStatisticsData::SetRedraw(BOOL bRedraw)
{
	EMULE_TRY

	if(g_bUseNewStyle)
	{
		m_ctrlStatsList.SetRedraw(bRedraw); 
		if(bRedraw)
		{
			m_ctrlStatsList.UpdatedItems();
			m_ctrlStatsList.Invalidate();
		}
	}
	else
	{
		stattree.SetRedraw(bRedraw);
		if(bRedraw)
		{
			stattree.Invalidate();
		}
	}

	EMULE_CATCH2
}

HWND CStatisticsData::GetListHWND()
{
	if(g_bUseNewStyle)
		return m_ctrlStatsList.GetSafeHwnd(); 
	else
		return stattree.GetSafeHwnd();
}

void CStatisticsData::ExpandAllItems()
{
	EMULE_TRY

	if(g_bUseNewStyle)
		m_ctrlStatsList.ExpandAllItems();
	else
	{
		for(int i = 0; i < m_DataList.GetCount(); i++)
			Expand(m_DataList[i]->m_nID, true);
	}

	EMULE_CATCH2
}

CString CStatisticsData::ExportHTML()
{
	EMULE_TRY

	CString sRet;
	for(int i = 0; i < m_DataList.GetCount(); i++)
	{
		for(uint32 j = 0; j < m_DataList[i]->m_nLevel; j++)
			sRet += _T("&nbsp;&nbsp;&nbsp;");
		if(!m_DataList[i]->m_nLevel)
			sRet += _T("<b>");
		sRet += m_DataList[i]->m_sTitle;
		if(!m_DataList[i]->m_nLevel)
			sRet += _T("</b>");
		if(!m_DataList[i]->m_sValue.IsEmpty())
			sRet += _T(": ") + m_DataList[i]->m_sValue;
		sRet += _T("<br>");
	}
	return sRet;

	EMULE_CATCH2

	return _T("");
}


// CStatisticsDlg dialog

IMPLEMENT_DYNAMIC(CStatisticsDlg, CDialog)
CStatisticsDlg::CStatisticsDlg(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CStatisticsDlg::IDD, pParent), m_DownloadOMeter(3),m_Statistics(4),m_UploadOMeter(3)
{
	EMULE_TRY

	m_bFirstShow = true;
	g_bUseNewStyle = !(LOBYTE(theApp.glob_prefs->GetWindowsVersion()) == 0x04);

	EMULE_CATCH2
}

CStatisticsDlg::~CStatisticsDlg()
{
	//The List elements deleted automatically so no need to delete them here
}

void CStatisticsDlg::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExoSliderDlg)
	DDX_Control(pDX, IDC_STATTREE, m_Stats.stattree);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStatisticsDlg, CResizableDialog)
	//{{AFX_MSG_MAP(CStatisticsDlg)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
	ON_WM_SIZE()
END_MESSAGE_MAP()


// CStatisticsDlg message handlers

BOOL CStatisticsDlg::OnInitDialog()
{
	EMULE_TRY

	CResizableDialog::OnInitDialog();
	Localize();
	EnableWindow( FALSE );
	
	// setup tree
	CreateStatsList();

	CRect rClient;
	GetClientRect(&rClient);

	// Setup download scope
	CRect rect;
	GetDlgItem(IDC_SCOPE_D)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_DownloadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this); 
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate()+4, 0);
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate()+4, 1);
	m_DownloadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphDownloadRate()+4, 2);
	m_DownloadOMeter.SetYUnits(GetResString(IDS_KBYTESEC));
	//m_DownloadOMeter.SetXUnits(GetResString(IDS_TIME));
	CSize sDlMeter[2];
	sDlMeter[0].cx = 100 * rect.left / rClient.Width();
	sDlMeter[0].cy = 100 * rect.top / rClient.Height();
	sDlMeter[1].cx = 100 * rect.right / rClient.Width();
	sDlMeter[1].cy = 100 * rect.bottom / rClient.Width();

	// Setup upload scope
	GetDlgItem(IDC_SCOPE_U)->GetWindowRect(rect);
	ScreenToClient(rect);
	m_UploadOMeter.Create(WS_VISIBLE | WS_CHILD, rect, this); 
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate()+4, 0);
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate()+4, 1);
	m_UploadOMeter.SetRange(0, theApp.glob_prefs->GetMaxGraphUploadRate()+4, 2);
	m_UploadOMeter.SetYUnits(GetResString(IDS_KBYTESEC));
	//m_UploadOMeter.SetXUnits(GetResString(IDS_TIME));
	CSize sUpMeter[2];
	sUpMeter[0].cx = 100 * rect.left / rClient.Width();
	sUpMeter[0].cy = 100 * rect.top / rClient.Height();
	sUpMeter[1].cx = 100 * rect.right / rClient.Width();
	sUpMeter[1].cy = 100 * rect.bottom / rClient.Height();

	// Setup connections scope
	GetDlgItem(IDC_STATSSCOPE)->GetWindowRect(rect) ;
	ScreenToClient(rect) ;
	m_Statistics.Create(WS_VISIBLE | WS_CHILD, rect, this) ; 
	m_Statistics.SetRanges(0, theApp.glob_prefs->GetStatsMax());
	m_Statistics.autofitYscale=false; // DonGato
	m_Statistics.SetYUnits("") ;
	m_Statistics.SetXUnits(GetResString(IDS_TIME));

	CSize sStatistics[2];
	sStatistics[0].cx = 100 * rect.left / rClient.Width();
	sStatistics[0].cy = 100 * rect.top / rClient.Height();
	sStatistics[1].cx = 100 * rect.right / rClient.Width();
	sStatistics[1].cy = 100 * rect.bottom  / rClient.Height();

	oldRatio=theApp.glob_prefs->GetGraphRatio();	//Cax2 - Resize active connections line...
	RepaintMeters();
	
	m_DownloadOMeter.InvalidateCtrl();
	m_UploadOMeter.InvalidateCtrl();
	m_Statistics.InvalidateCtrl();

	if (theApp.glob_prefs->GetStatsInterval()==0) GetDlgItem(IDC_STATTREE)->EnableWindow(false);

	UpdateData(FALSE);

	EnableWindow( TRUE );

	m_ilastMaxConnReached = 0;
	peakconnections = 0;
	totalconnectionchecks = 0;
	averageconnections = 0;
	activeconnections = 0;
	maxDown=0;
	maxDownavg=0;
	
	AddAnchor(m_Stats.GetListHWND(), TOP_LEFT, BOTTOM_CENTER);

	AddAnchor(IDC_SCOPE_D, TOP_CENTER, CSize(100,34));
	AddAnchor(m_DownloadOMeter.m_hWnd, TOP_CENTER, CSize(100,34));
	AddAnchor(IDC_SCOPE_U, CSize(50,34), CSize(100,68));
	AddAnchor(m_UploadOMeter.m_hWnd, CSize(50,34), CSize(100,68));
	AddAnchor(IDC_STATSSCOPE, CSize(50,68), BOTTOM_RIGHT);
	AddAnchor(m_Statistics.m_hWnd, CSize(50,68), BOTTOM_RIGHT);
	
	AddAnchor(IDC_STATIC_D3, TOP_CENTER);
	AddAnchor(IDC_C0, TOP_RIGHT);
	AddAnchor(IDC_STATIC_D, TOP_RIGHT);
	AddAnchor(IDC_C0_3, TOP_RIGHT);
	AddAnchor(IDC_TIMEAVG1, TOP_RIGHT);
	AddAnchor(IDC_C0_2, TOP_RIGHT);
	AddAnchor(IDC_STATIC_D2, TOP_RIGHT);
	AddAnchor(m_Led1[0].m_hWnd, TOP_RIGHT);
	AddAnchor(m_Led1[1].m_hWnd, TOP_RIGHT);
	AddAnchor(m_Led1[2].m_hWnd, TOP_RIGHT);
	
	AddAnchor(IDC_STATIC_U, CSize(50,34));
	AddAnchor(IDC_C1, CSize(100,34));
	AddAnchor(IDC_STATIC_U2, CSize(100,34));
	AddAnchor(IDC_C1_3, CSize(100,34));
	AddAnchor(IDC_TIMEAVG2, CSize(100,34));
	AddAnchor(IDC_C1_2, CSize(100,34));
	AddAnchor(IDC_STATIC_U3, CSize(100,34));
	AddAnchor(m_Led2[0].m_hWnd, CSize(100,34));
	AddAnchor(m_Led2[1].m_hWnd, CSize(100,34));
	AddAnchor(m_Led2[2].m_hWnd, CSize(100,34));
	
	AddAnchor(IDC_STATIC_A, CSize(50,68));
	AddAnchor(IDC_S3, CSize(100,68));
	AddAnchor(IDC_STATIC_S2, CSize(100,68));
	AddAnchor(IDC_S0, CSize(100,68));
	AddAnchor(IDC_STATIC_S0, CSize(100,68));
	AddAnchor(IDC_S1, CSize(100,68));
	AddAnchor(IDC_STATIC_S1, CSize(100,68));
	AddAnchor(m_Led3[1].m_hWnd, CSize(100,68));
	AddAnchor(m_Led3[0].m_hWnd, CSize(100,68));
	AddAnchor(m_Led3[3].m_hWnd, CSize(100,68));

	AddAnchor(IDC_S2, CSize(50,100));
	AddAnchor(IDC_STATIC_S3, CSize(50,100));
	
	ShowStatistics();
	return true;

	EMULE_CATCH

	return false;
}

void CStatisticsDlg::SetupLegend( int ResIdx, int ElmtIdx, int legendNr)
{
	EMULE_TRY

	CRect Rect;

	GetDlgItem( ResIdx )->GetWindowRect( Rect );
	ScreenToClient( Rect );
	
	if (legendNr==1){
		if (!m_Led1[ElmtIdx]) m_Led1[ElmtIdx].Create(WS_VISIBLE | WS_CHILD, Rect, this);
		m_Led1[ElmtIdx].SetBackgroundColor(m_DownloadOMeter.GetPlotColor(ElmtIdx));
		m_Led1[ElmtIdx].SetFrameColor(RGB(0x00, 0x00, 0x00));
	} else if (legendNr==2) {
		if (!m_Led2[ElmtIdx]) m_Led2[ElmtIdx].Create( WS_VISIBLE | WS_CHILD, Rect, this);
		m_Led2[ElmtIdx].SetBackgroundColor(m_UploadOMeter.GetPlotColor(ElmtIdx));
		m_Led2[ElmtIdx].SetFrameColor(RGB(0x00, 0x00, 0x00));
	} else if (legendNr==3){
		if (!m_Led3[ElmtIdx]) m_Led3[ElmtIdx].Create(WS_VISIBLE | WS_CHILD, Rect, this);
		m_Led3[ElmtIdx].SetBackgroundColor(m_Statistics.GetPlotColor(ElmtIdx));
		m_Led3[ElmtIdx].SetFrameColor(RGB(0x00, 0x00, 0x00));
	}

	EMULE_CATCH
}

void CStatisticsDlg::RepaintMeters() 
{
	EMULE_TRY

	m_DownloadOMeter.SetBackgroundColor(theApp.glob_prefs->GetStatsColor(0));
	m_DownloadOMeter.SetGridColor(theApp.glob_prefs->GetStatsColor(1));
	m_DownloadOMeter.SetPlotColor( theApp.glob_prefs->GetStatsColor(4) ,0);
	m_DownloadOMeter.SetPlotColor( theApp.glob_prefs->GetStatsColor(3) ,1);
	m_DownloadOMeter.SetPlotColor( theApp.glob_prefs->GetStatsColor(2) ,2);
	m_UploadOMeter.SetBackgroundColor(theApp.glob_prefs->GetStatsColor(0));
	m_UploadOMeter.SetGridColor(theApp.glob_prefs->GetStatsColor(1));
	m_UploadOMeter.SetPlotColor( theApp.glob_prefs->GetStatsColor(7) ,0);
	m_UploadOMeter.SetPlotColor( theApp.glob_prefs->GetStatsColor(6) ,1);
	m_UploadOMeter.SetPlotColor( theApp.glob_prefs->GetStatsColor(5) ,2);
	m_Statistics.SetBackgroundColor(theApp.glob_prefs->GetStatsColor(0));
	m_Statistics.SetGridColor(theApp.glob_prefs->GetStatsColor(1));
	m_Statistics.SetPlotColor( theApp.glob_prefs->GetStatsColor(8),0);
	m_Statistics.SetPlotColor( theApp.glob_prefs->GetStatsColor(9),1);
	//m_Statistics.SetPlotColor( theApp.glob_prefs->GetStatsColor(10),2);
	m_Statistics.SetPlotColor( theApp.glob_prefs->GetStatsColor(10),3);

	if (oldRatio!=theApp.glob_prefs->GetGraphRatio())	//Cax2 - Resize the general connections...
	{
		m_Statistics.ReSizePlot(0,(double)oldRatio/theApp.glob_prefs->GetGraphRatio());
		oldRatio=theApp.glob_prefs->GetGraphRatio();
	}
	m_Statistics.Invalidate();
	SetupLegend( IDC_C0_2, 0 ,1);
	SetupLegend( IDC_C0_3, 1 ,1);
	SetupLegend( IDC_C0,   2 ,1);
	
	SetupLegend( IDC_C1_2, 0 ,2);
	SetupLegend( IDC_C1_3, 1 ,2);
	SetupLegend( IDC_C1,   2 ,2);
	
	SetupLegend( IDC_S0,   0 ,3);
	SetupLegend( IDC_S1,   1 ,3);
	//SetupLegend( IDC_S2, 2 ,3);
	SetupLegend( IDC_S3,   3 ,3);
	EnableWindow(TRUE);		//Cax2 show the updated graphs immediately!

	EMULE_CATCH
}



void CStatisticsDlg::SetCurrentRate(float uploadrate, float downloadrate) 
{
	EMULE_TRY

	double m_dPlotDataUp[ 3 ];
	double m_dPlotDataDown[ 3 ];
	int myRateStats[3] = {0};

	// kuchin
	UpDown updown;
	updown.upload = uploadrate;
	updown.download = downloadrate;
	theApp.webserver->AddStatsLine(updown);

	// current rate
	m_dPlotDataDown[2]=downloadrate;
	m_dPlotDataUp[2]=uploadrate;

	if (maxDown<downloadrate) maxDown=downloadrate;
	
	// averages
	m_dPlotDataDown[0]=	GetAvgDownloadRate(AVG_SESSION);
	m_dPlotDataUp[0]=	GetAvgUploadRate(AVG_SESSION);

	m_dPlotDataDown[1]=	GetAvgDownloadRate(AVG_TIME);
	m_dPlotDataUp[1]=	GetAvgUploadRate(AVG_TIME);

	// show
	m_DownloadOMeter.AppendPoints(m_dPlotDataDown);
	m_UploadOMeter.AppendPoints(m_dPlotDataUp);


	// get Partialfiles summary
	activeconnections = theApp.listensocket->GetOpenSockets();

	theApp.downloadqueue->GetDownloadStats(myRateStats);
	m_dPlotDataMore[0]=(activeconnections/theApp.glob_prefs->GetGraphRatio());//myRateStats[0]; // propstats Cax2
	m_dPlotDataMore[1]=theApp.uploadqueue->GetUploadQueueLength();
	m_dPlotDataMore[2]=0;//theApp.uploadqueue->GetWaitingUserCount();
	m_dPlotDataMore[3]=myRateStats[1];

	m_Statistics.AppendPoints(m_dPlotDataMore);

	EMULE_CATCH
}

void CStatisticsDlg::UpdateConnectionsStatus()
{
	EMULE_TRY

	if( peakconnections < activeconnections )
		peakconnections = activeconnections;
	if( theApp.serverconnect->IsConnected() ){
	totalconnectionchecks++;
	float percent;
	percent = (float)((float)(totalconnectionchecks-1)/(float)totalconnectionchecks);
	if( percent > .99 )
		percent = (float).99;
	averageconnections = (averageconnections*percent) + (float)((float)activeconnections*(float)(1-percent));
	}

	EMULE_CATCH
}

float CStatisticsDlg::GetMaxConperFiveModifier(){
	//This is a alpha test.. Will clean up for b version.
	float SpikeSize = theApp.listensocket->GetOpenSockets() - averageconnections ;
	if ( SpikeSize < 1 )
		return 1;
	float SpikeTolerance = 25*(float)theApp.glob_prefs->GetMaxConperFive()/(float)10;
	if ( SpikeSize > SpikeTolerance )
		return 0;
	float Modifier = (1-(SpikeSize/SpikeTolerance));
	return Modifier;
}

void CStatisticsDlg::RecordRate() 
{
	EMULE_TRY
	
	if (theApp.stat_transferStarttime==0) return;

	// Cax 2 - save every 10th of the statsaverageminutes
	// no need to be more accurate...
	DWORD tickNow=GetTickCount();
	DWORD nUpdateTime =theApp.glob_prefs->GetStatsAverageMinutes()*6000;		//A 10th of the average interval
	if (tickNow-timeHistory.front()<nUpdateTime) //too little time has passed since we updated the list last
		return;
	
	downrateHistory.push_front(theApp.stat_sessionReceivedBytes);
	uprateHistory.push_front(theApp.stat_sessionSentBytes);
	timeHistory.push_front(tickNow);
	
	// limit to maxmins 
	nUpdateTime *= 10; //Now we finally get the average interval expressed in ticks!
	while (tickNow-timeHistory.back()>nUpdateTime)		//Cax2 - keep them in sync

	{
		downrateHistory.pop_back();
		uprateHistory.pop_back();
		timeHistory.pop_back();
	}

	EMULE_CATCH
}

void CStatisticsDlg::ShowStatistics() 
{
	EMULE_TRY

	m_Stats.SetRedraw(FALSE);
	
	char buffer[100];char buffer2[100];
	CString cbuffer;
	bool resize;
	DWORD running;
	int myStats[SO_LAST];
	int myRateStats[3];
	float DownAvgRate;

	uint64 ui64TotFileSize=0; 
	uint64 ui64TotBytesLeftToTransfer=0;
	uint64 ui64TotNeededSpace=0;

	resize = false;
	UpdateConnectionsStatus();
	theApp.downloadqueue->GetDownloadStats(myRateStats,ui64TotFileSize,ui64TotBytesLeftToTransfer,ui64TotNeededSpace);	// changed by InterCeptor (xChipx: download statistics) 11.11.02

	uint64 ui64BytesTransfered;
	uint64 t_FreeBytes=0;
	float fPercent = 0.0f;

	cbuffer.Format(GetResString(IDS_DWTOT_NR),myRateStats[2]); 
	m_Stats.SetValue(STATS_TOTALDOWN_TOTAL, cbuffer);

	CastItoXBytes(ui64TotFileSize,buffer,100); 
	cbuffer.Format(GetResString(IDS_DWTOT_TSD),buffer); 
	m_Stats.SetValue(STATS_TOTALDOWN_TOTALSIZE, cbuffer);

	ui64BytesTransfered = (ui64TotFileSize-ui64TotBytesLeftToTransfer);
	CastItoXBytes(ui64BytesTransfered,buffer,100); 
	if(ui64TotFileSize != 0)
	fPercent = (float)((ui64BytesTransfered*100)/(ui64TotFileSize)); //kuchin
	cbuffer.Format(GetResString(IDS_DWTOT_TCS),buffer,fPercent); 
	m_Stats.SetValue(STATS_TOTALDOWN_DOWNLOADED, cbuffer);

	CastItoXBytes(ui64TotBytesLeftToTransfer,buffer,100);
	cbuffer.Format(GetResString(IDS_DWTOT_TSL),buffer); 
	m_Stats.SetValue(STATS_TOTALDOWN_LEFT, cbuffer);

	CastItoXBytes(ui64TotNeededSpace,buffer,100); 
	cbuffer.Format(GetResString(IDS_DWTOT_TSN),buffer); 
	m_Stats.SetValue(STATS_TOTALDOWN_NEEDSPACE, cbuffer);

	t_FreeBytes = GetFreeDiskSpaceX(theApp.glob_prefs->GetTempDir().GetBuffer());
	CastItoXBytes(t_FreeBytes,buffer,100); 
	sprintf(buffer2,GetResString(IDS_DWTOT_FS),buffer);

	if(ui64TotNeededSpace > t_FreeBytes)
	{
		CastItoXBytes(ui64TotNeededSpace - t_FreeBytes,buffer,100);
		cbuffer.Format(GetResString(IDS_NEEDFREEDISKSPACE),buffer2,buffer);
	}
	else
		cbuffer.Format("%s",buffer2);
	m_Stats.SetValue(STATS_TOTALDOWN_SPACELEFT, cbuffer);

	CastItoXBytes(theApp.stat_sessionReceivedBytes, buffer,100);
	CastItoXBytes(theApp.stat_sessionReceivedBytes+theApp.glob_prefs->GetTotalDownloaded(),	buffer2,100);
	cbuffer.Format(GetResString(IDS_STATS_DDATA), buffer, buffer2);
	m_Stats.SetValue(STATS_TRANSFER_DOWNLOADS_TRANSFERRED, cbuffer);

	CastItoXBytes(theApp.stat_sessionSentBytes, buffer,100);
	CastItoXBytes(theApp.stat_sessionSentBytes+theApp.glob_prefs->GetTotalUploaded(), buffer2,100);
	cbuffer.Format(GetResString(IDS_STATS_UDATA), buffer, buffer2);
	m_Stats.SetValue(STATS_TRANSFER_UPLOADS_TRANSFERRED, cbuffer);

	if(theApp.stat_transferStarttime>0) 
	{
		cbuffer.Format(GetResString(IDS_STATS_AVGDL), GetAvgDownloadRate(AVG_SESSION));
		m_Stats.SetValue(STATS_CONNECTION_AVGDOWNLOADRATE, cbuffer);

		cbuffer.Format(GetResString(IDS_STATS_AVGUL), GetAvgUploadRate(AVG_SESSION));
		m_Stats.SetValue(STATS_CONNECTION_AVGUPLOADRATE, cbuffer);

		DownAvgRate=GetAvgDownloadRate(AVG_SESSION);
		if (maxDownavg<DownAvgRate) maxDownavg=DownAvgRate;
		cbuffer.Format(GetResString(IDS_STATS_MAXAVGDL),maxDownavg);
		m_Stats.SetValue(STATS_CONNECTION_MAXDOWNLOADRATEAVG, cbuffer);
		cbuffer.Format(GetResString(IDS_STATS_MAXDL),maxDown);
		m_Stats.SetValue(STATS_CONNECTION_MAXDOWNLOADRATESESSION, cbuffer);
	}

	cbuffer.Format(GetResString(IDS_STATS_FOUNDSRC), myRateStats[0]);
	m_Stats.SetValue(STATS_TRANSFER_DOWNLOADS_SOURCES, cbuffer);

	cbuffer.Format(GetResString(IDS_STATS_ACTDL), myRateStats[1]);
	m_Stats.SetValue(STATS_TRANSFER_DOWNLOADS_ACTIVE, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_UDPSEARCH), theApp.downloadqueue->GetUDPSearchStatus());
	m_Stats.SetValue(STATS_TRANSFER_DOWNLOADS_UDPSEARCH, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_ACTUL), theApp.uploadqueue->GetUploadQueueLength());
	m_Stats.SetValue(STATS_TRANSFER_UPLOADS_ACTIVE, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_WAITINGUSERS), theApp.uploadqueue->GetWaitingUserCount());
	m_Stats.SetValue(STATS_TRANSFER_UPLOADS_WAITING, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_SUCCUPCOUNT), theApp.uploadqueue->GetSuccessfullUpCount());
	m_Stats.SetValue(STATS_TRANSFER_UPLOADS_SUCCEEDED, cbuffer);
	cbuffer.Format(GetResString(IDS_STATS_FAILUPCOUNT), theApp.uploadqueue->GetFailedUpCount());
	m_Stats.SetValue(STATS_TRANSFER_UPLOADS_FAILED, cbuffer);
	running=theApp.uploadqueue->GetAverageUpTime();
	CastSecondsToHM(running, buffer,100);
	cbuffer.Format(GetResString(IDS_STATS_AVEUPTIME), buffer);
	m_Stats.SetValue(STATS_TRANSFER_UPLOADS_AVGTIME, cbuffer);

	if(theApp.stat_reconnects>0) 
		cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),theApp.stat_reconnects-1);
	else 
		cbuffer.Format(GetResString(IDS_STATS_RECONNECTS),0);
	
	m_Stats.SetValue(STATS_CONNECTION_RECONNECTED, cbuffer);

	if(theApp.stat_transferStarttime==0) 
		cbuffer.Format(GetResString(IDS_STATS_WAITTRANSF)); 
	else 
	{
		running = (GetTickCount()-theApp.stat_transferStarttime) / 1000;
		CastSecondsToHM(running, buffer,100);
		cbuffer.Format(GetResString(IDS_TRANSFERTIME), buffer);
	}
	m_Stats.SetValue(STATS_CONNECTION_SINCEFIRSTTRANSFER, cbuffer);

	if(theApp.stat_serverConnectTime==0) 
		cbuffer.Format(GetResString(IDS_STATS_WAITCONN)); 
	else 
	{
		running=(GetTickCount()-theApp.stat_serverConnectTime)/1000;
		CastSecondsToHM(running,buffer,100);
		cbuffer.Format(GetResString(IDS_STATS_CONNECTEDSINCE),buffer);
	}
	m_Stats.SetValue(STATS_CONNECTION_CONNECTEDSINCE, cbuffer);

	if(theApp.stat_sessionReceivedBytes >0 && theApp.stat_sessionSentBytes >0)
	{	
		if(theApp.stat_sessionReceivedBytes<theApp.stat_sessionSentBytes) 
			cbuffer.Format("%.2f : 1",(float)theApp.stat_sessionSentBytes/theApp.stat_sessionReceivedBytes);
		else 
			cbuffer.Format("1 : %.2f",(float)theApp.stat_sessionReceivedBytes/theApp.stat_sessionSentBytes);

		m_Stats.SetTitle(STATS_TRANSFER_SESSIONRATIO, GetResString(IDS_STATS_RATIO));
		m_Stats.SetStatic(STATS_TRANSFER_SESSIONRATIO, cbuffer);
	}
		
	// shared files stats
	cbuffer.Format(GetResString(IDS_SHAREDFILESCOUNT),theApp.sharedfiles->GetCount());
	m_Stats.SetValue(STATS_SHAREDFILES_TOTAL, cbuffer);

	uint64 allsize=theApp.sharedfiles->GetDatasize();
	CastItoXBytes(allsize,buffer,100);

	cbuffer.Format(GetResString(IDS_SF_SIZE), buffer);
	m_Stats.SetValue(STATS_SHAREDFILES_TOTALSIZE, cbuffer);

	if(theApp.sharedfiles->GetCount() != 0)
		CastItoXBytes((uint64)allsize/theApp.sharedfiles->GetCount(), buffer,100);
	else 
	{
		buffer[0] = '-';
		buffer[1] = 0;
	}
	cbuffer.Format(GetResString(IDS_SF_AVERAGESIZE),buffer);
	m_Stats.SetValue(STATS_SHAREDFILES_AVGSIZE, cbuffer);

	// xrmb : statsclientstatus
	ClientsData AllClients;
	// get clientversion-counts

	uint32 totalclient;
	theApp.clientlist->GetStatistics(totalclient,myStats, &AllClients);
	totalclient -= myStats[SO_UNKNOWN];
	if( !totalclient )
		totalclient = 1;
	//Cax2 - not good... 3 different functions need to be kept in sync for this for() to work properly.
	for(int j = STATS_QUEUE_TRANSFERRING; j <= STATS_QUEUE_TRANSFERRING+DS_NONE-1; j++)	//Cax2 - removed unknown... it confused people!
	{
		int n = j - STATS_QUEUE_TRANSFERRING;
		cbuffer.Format("%s: %i", GetStatusDLQueueString((eDLQState)n), AllClients.m_pClients[SO_LAST][n]);

		m_Stats.SetValue(j, cbuffer);
	}

	// For all KNOWN clients types
	//Cax2 - hmmm, weird loop....
	uint32 iSoftTot;
	uint32 iSubTot;
	for ( j = 0; j < (uint32)SO_UNKNOWN ; j ++ )
	{
		// Add client type //Cax2 - Exception! emules &  old emules lumped together in the stats now...
		iSoftTot=myStats[j]+((j==(int)SO_EMULE)?myStats[(int)SO_OLDEMULE]:0);
		if (j!=(int)SO_OLDEMULE)
		{
			cbuffer.Format("%s: %i (%1.1f%%)",GetClientNameString((eClientTypes)j),iSoftTot,(double)100*iSoftTot/totalclient);
			m_Stats.SetValue(STATS_CLIENTS + j*4 + 1, cbuffer);
		}
		//--- find top 3 client versions ---
		uint32	currtop=0, lasttop=0xFFFFFFFF;
		if (j!=(int)SO_CDONKEY && j!=(int)SO_MLDONKEY && j!=(int)SO_OLDEMULE)	//Cax2 - these clients won't show subcats
		{
			iSubTot=0;
			for(int i=0; i<3; i++)
			{
				POSITION pos=AllClients.m_pClients[j].GetStartPosition();
				uint32	topver=0;
				uint32	topcnt=0;
				uint32	totcnt=0;
				uint32	ver;
				uint32	cnt;
				while(pos)
				{
					AllClients.m_pClients[j].GetNextAssoc(pos, ver, cnt);
					totcnt+=cnt;
					if(currtop<cnt && cnt<lasttop)
					{
						topver=ver;
						topcnt=cnt;
						currtop=cnt;
					}
				}
				lasttop=currtop;
				currtop=0;
				if(topcnt)
				{
					iSubTot+=topcnt;
					cbuffer.Format("v%s: %i (%1.1f%%)", GetClientVersionString((eClientTypes)j,topver), topcnt, (double)topcnt/totcnt*100);
				}
				else
					cbuffer.Format(GetResString(IDS_FSTAT_WAITING)+": ");//Cax2 - clears the stats from old data...
				m_Stats.SetValue(STATS_CLIENTS + j*4 + i + 2, cbuffer); 
			}
			if (j==(int)SO_EMULE)
			{
				if (iSoftTot>iSubTot)		//Cax2 - show only if > 0...
					cbuffer.Format("%s: %i (%1.1f%%)",GetResString(IDS_STATS_UNKNOWNCLIENT),iSoftTot-iSubTot,(double)100*(iSoftTot-iSubTot)/iSoftTot);
				else
					cbuffer.Format(GetResString(IDS_FSTAT_WAITING)+": ");//Cax2 - clears the stats from old data...
				m_Stats.SetValue(STATS_CLIENTS_EMULE_OTHER, cbuffer);
			}
		}
	}
	// UNKNOWN should be added separately because it does not have versions
	cbuffer.Format("%s: %i(%1.1f%%)",GetClientNameString(SO_UNKNOWN),myStats[SO_UNKNOWN],(double)100*myStats[SO_UNKNOWN]/(totalclient+myStats[SO_UNKNOWN]));
	m_Stats.SetValue(STATS_CLIENTS_UNKNOWN, cbuffer);
	
	// xrmb

	uint32 servtotal;
	uint32 servfail;
	uint32 servuser;
	uint32 servfile;
	uint32 servtuser;
	uint32 servtfile;
	float servocc;
	theApp.serverlist->GetStatus(servtotal, servfail, servuser, servfile, servtuser, servtfile, servocc);
	cbuffer.Format(GetResString(IDS_SF_WORKING)+": %i",servtotal-servfail);
	m_Stats.SetValue(STATS_SERVERS_WORKING, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_FAIL)+": %i",servfail);
	m_Stats.SetValue(STATS_SERVERS_BAD, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_TOTAL)+": %i",servtotal);
	m_Stats.SetValue(STATS_SERVERS_TOTAL, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_DELCOUNT)+": %i",theApp.serverlist->GetDeletedServerCount());
	m_Stats.SetValue(STATS_SERVERS_DELETED, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_WUSER)+": %i",servuser);
	m_Stats.SetValue(STATS_SERVERS_WORKINGUSERS, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_WFILE)+": %i",servfile);
	m_Stats.SetValue(STATS_SERVERS_WORKINGFILES, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_USER)+": %i",servtuser);
	m_Stats.SetValue(STATS_SERVERS_TOTALUSERS, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_FILE)+": %i",servtfile);
	m_Stats.SetValue(STATS_SERVERS_TOTALFILES, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_ACTIVECON)+": %i",activeconnections);
	m_Stats.SetValue(STATS_CONNECTION_ACTIVE, cbuffer);
	cbuffer.Format(GetResString(IDS_SF_SRVOCC),servocc);
	m_Stats.SetValue(STATS_CONNECTION_MAXTIME, cbuffer);
	uint32 m_itemp = theApp.listensocket->GetMaxConnectionReached();
	if(m_itemp != m_ilastMaxConnReached)
	{
		COleDateTime time(COleDateTime::GetCurrentTime());
		cbuffer.Format(GetResString(IDS_SF_MAXCONLIMITREACHED)+": %i : %s",m_itemp,time.Format());
		m_Stats.SetValue(STATS_CONNECTION_MAXTIME, cbuffer);
		m_ilastMaxConnReached = m_itemp;
	}
	else if(m_itemp == 0)
	{
		cbuffer.Format(GetResString(IDS_SF_MAXCONLIMITREACHED)+": %i",m_itemp);
		m_Stats.SetValue(STATS_CONNECTION_MAXTIME, cbuffer);
	}	
	if(theApp.serverconnect->IsConnected())
	{
		cbuffer.Format(GetResString(IDS_SF_AVGCON)+": %i",(int)averageconnections);
		m_Stats.SetValue(STATS_CONNECTION_AVERAGE, cbuffer);
	}
	else
	{
		cbuffer.Format(GetResString(IDS_STATS_WAITCONN));
		m_Stats.SetValue(STATS_CONNECTION_AVERAGE, cbuffer);
	}

	cbuffer.Format(GetResString(IDS_SF_PEAKCON)+": %i",peakconnections);
	m_Stats.SetValue(STATS_CONNECTION_MAXIMUM, cbuffer);
	
	m_Stats.SetRedraw(TRUE);

	EMULE_CATCH
}

float CStatisticsDlg::GetAvgDownloadRate(int averageType) 
{
	EMULE_TRY
		
	if (averageType==AVG_SESSION)
	{
		if (theApp.stat_transferStarttime ==0) return 0;
		DWORD running=(float)(GetTickCount()-theApp.stat_transferStarttime)/1000+.5;		//Cax2 - not really needed here, but the math is 'right' now!
		if (running<5) return 0;
		return (float)(theApp.stat_sessionReceivedBytes/1024) / running;
	} else {
		if (downrateHistory.empty()) return 0;
		//return ((downrateHistory.front()-downrateHistory.back())/1024.0f)*1000/(timeHistory.front()-timeHistory.back()+.5);
		//Cax2 - we could use that formula... but it's faster if we compute that ratio beforehand, 
		//Cax2 - & more accurate if we use the actual data we have now instead of the front of the list.
		return (theApp.stat_sessionReceivedBytes-downrateHistory.back())*.9765/(GetTickCount()-timeHistory.back());
	}

	EMULE_CATCH

	return 0.0f;
}

float CStatisticsDlg::GetAvgUploadRate(int averageType) 
{
	EMULE_TRY

	if (averageType==AVG_SESSION) {
		if (theApp.stat_transferStarttime==0) return 0;

		DWORD running=(float)(GetTickCount()-theApp.stat_transferStarttime)/1000+.5;		//Cax2 - stops the sudden session upload average 'jump' at the beginning.
		if (running<5) return 0;

		return (float)(theApp.stat_sessionSentBytes/1024) / running;
	} else  {
		if (downrateHistory.empty()) return 0;
		//Cax2 - precomputed ratio. see above
		return (theApp.stat_sessionSentBytes-uprateHistory.back())*.9765/(GetTickCount()-timeHistory.back());
	}

	EMULE_CATCH

	return 0.0f;
}

void CStatisticsDlg::OnShowWindow(BOOL bShow,UINT nStatus)
{
	EMULE_TRY

	if(bShow && m_bFirstShow && g_bUseNewStyle)
	{
		m_bFirstShow = false;
		m_Stats.SetColumn(theApp.glob_prefs->GetStatsColumnWidth());
	}

	EMULE_CATCH
}

void CStatisticsDlg::ShowInterval() 
{
	EMULE_TRY

	EnableWindow(FALSE);

	if(!m_DownloadOMeter.GetSafeHwnd() || !m_UploadOMeter.GetSafeHwnd())
		return;	
	
	CRect r;
	m_DownloadOMeter.GetPlotRect(r);
	int shownSecs = r.Width() * theApp.glob_prefs->GetTrafficOMeterInterval();
	
	
	if(theApp.glob_prefs->GetTrafficOMeterInterval()==0) 
	{
		m_DownloadOMeter.SetXUnits(GetResString(IDS_STOPPED)); 
		m_UploadOMeter.SetXUnits(GetResString(IDS_STOPPED)); 
	} 
	else
	{
		char buffer[100];
		CastSecondsToHM(shownSecs,buffer,100);
		m_UploadOMeter.SetXUnits(buffer);
		m_DownloadOMeter.SetXUnits(buffer); 
	}

	UpdateData(FALSE);
	EnableWindow(TRUE);

	EMULE_CATCH
}

void CStatisticsDlg::SetARange(bool SetDownload,int maxValue)
{
	EMULE_TRY

	if (SetDownload)
	{
		m_DownloadOMeter.SetRange(0, maxValue+4, 0);
		m_DownloadOMeter.SetRange(0, maxValue+4, 1);
		m_DownloadOMeter.SetRange(0, maxValue+4, 2);
	}
	else
	{
		m_UploadOMeter.SetRange(0, maxValue+4, 0);
		m_UploadOMeter.SetRange(0, maxValue+4, 1);
		m_UploadOMeter.SetRange(0, maxValue+4, 2);
	}

	EMULE_CATCH
}

void CStatisticsDlg::Localize()
{
	EMULE_TRY

	GetDlgItem(IDC_STATIC_D3)->SetWindowText(GetResString(IDS_ST_DOWNLOAD));
	GetDlgItem(IDC_STATIC_U)->SetWindowText(GetResString(IDS_ST_UPLOAD));
	GetDlgItem(IDC_STATIC_D)->SetWindowText(GetResString(IDS_ST_CURRENT).MakeLower());
	GetDlgItem(IDC_STATIC_U2)->SetWindowText(GetResString(IDS_ST_CURRENT).MakeLower());
	GetDlgItem(IDC_STATIC_D2)->SetWindowText(GetResString(IDS_ST_SESSION).MakeLower());
	GetDlgItem(IDC_STATIC_U3)->SetWindowText(GetResString(IDS_ST_SESSION).MakeLower());
	GetDlgItem(IDC_STATIC_A)->SetWindowText(GetResString(IDS_SP_ACTCON));

	GetDlgItem(IDC_STATIC_S2)->SetWindowText(GetResString(IDS_ST_ACTIVEDOWNLOAD).MakeLower());
	CString value;
	if (theApp.glob_prefs->GetGraphRatio()>1)
		value.Format(" (1:%i)",theApp.glob_prefs->GetGraphRatio());
	GetDlgItem(IDC_STATIC_S0)->SetWindowText(GetResString(IDS_PW_GENERAL).MakeLower()+value);
	GetDlgItem(IDC_STATIC_S1)->SetWindowText((LPCTSTR)GetResString(IDS_ST_ACTIVEUPLOAD).MakeLower());
	value.Format(" (%u "+ GetResString(IDS_MINS) + ")",theApp.glob_prefs->GetStatsAverageMinutes());
	GetDlgItem(IDC_TIMEAVG1)->SetWindowText((LPCTSTR)GetResString(IDS_AVG).MakeLower() + value);
	GetDlgItem(IDC_TIMEAVG2)->SetWindowText((LPCTSTR)GetResString(IDS_AVG).MakeLower() + value);

	if(m_Stats.GetListHWND())
	{								
		m_Stats.SetTitle(STATS_TRANSFER, GetResString(IDS_FSTAT_TRANSFER));
		m_Stats.SetTitle(STATS_TRANSFER_UPLOADS, GetResString(IDS_TW_UPLOADS));
		m_Stats.SetTitle(STATS_TRANSFER_DOWNLOADS, GetResString(IDS_TW_DOWNLOADS));
		m_Stats.SetTitle(STATS_CONNECTION, GetResString(IDS_FSTAT_CONNECTION));
		m_Stats.SetTitle(STATS_CLIENTS, GetResString(IDS_CLIENTS));
		m_Stats.SetTitle(STATS_QUEUE, GetResString(IDS_QUEUE));
		m_Stats.SetTitle(STATS_SERVERS, GetResString(IDS_FSTAT_SERVERS));
		m_Stats.SetTitle(STATS_SHAREDFILES, GetResString(IDS_SHAREDFILES));
		m_Stats.SetTitle(STATS_TOTALDOWN, GetResString(IDS_DWTOT));
	}

	EMULE_CATCH
}

void CStatisticsDlg::OnSize(UINT nType, int cx, int cy)
{
	CResizableDialog::OnSize(nType, cx, cy);
	ShowInterval();
}

void CStatisticsDlg::CreateStatsList()
{
	EMULE_TRY

	if(g_bUseNewStyle)
	{
		CRect r;
		GetDlgItem(IDC_STATTREE)->GetWindowRect(r);
		ScreenToClient(r);
		m_Stats.CreateNewStyle(this, r);
	}
	else
	{
		m_Stats.stattree.EnableWindow();
		m_Stats.stattree.ShowWindow(SW_SHOW);
	}
	m_Stats.SetRedraw(FALSE);
	
	m_Stats.AddEntry(STATS_TRANSFER, GetResString(IDS_FSTAT_TRANSFER), 0);
	m_Stats.AddEntry(STATS_TRANSFER_SESSIONRATIO, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_TRANSFER_UPLOADS, GetResString(IDS_TW_UPLOADS), 1);
	m_Stats.AddEntry(STATS_TRANSFER_UPLOADS_TRANSFERRED, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_UPLOADS_ACTIVE, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_UPLOADS_WAITING, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_UPLOADS_SUCCEEDED, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_UPLOADS_FAILED, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_UPLOADS_AVGTIME, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_DOWNLOADS, GetResString(IDS_TW_DOWNLOADS), 1);
	m_Stats.AddEntry(STATS_TRANSFER_DOWNLOADS_TRANSFERRED, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_DOWNLOADS_SOURCES, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_DOWNLOADS_ACTIVE, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_TRANSFER_DOWNLOADS_UDPSEARCH, GetResString(IDS_FSTAT_WAITING), 2);

	m_Stats.AddEntry(STATS_CONNECTION, GetResString(IDS_FSTAT_CONNECTION), 0);
	m_Stats.AddEntry(STATS_CONNECTION_AVGDOWNLOADRATE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_AVGUPLOADRATE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_MAXDOWNLOADRATEAVG, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_MAXDOWNLOADRATESESSION, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_RECONNECTED, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_SINCEFIRSTTRANSFER, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_CONNECTEDSINCE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_ACTIVE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_MAXTIME, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_AVERAGE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CONNECTION_MAXIMUM, GetResString(IDS_FSTAT_WAITING), 1);

	m_Stats.AddEntry(STATS_CLIENTS, GetResString(IDS_CLIENTS), 0);
	m_Stats.AddEntry(STATS_CLIENTS_EMULE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CLIENTS_EMULE_1, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EMULE_2, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EMULE_3, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EMULE_OTHER, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EDONKEYHYBRID, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CLIENTS_EDONKEYHYBRID_1, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EDONKEYHYBRID_2, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EDONKEYHYBRID_3, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EDONKEY, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_CLIENTS_EDONKEY_1, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EDONKEY_2, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_EDONKEY_3, GetResString(IDS_FSTAT_WAITING), 2);
	//Cax2 - old emule stats integrated with emule now...
	//m_Stats.AddEntry(STATS_CLIENTS_OLDEMULE, GetResString(IDS_FSTAT_WAITING), 1);
	//Cax2 - no need to have 3 subcats for that!
	//m_Stats.AddEntry(STATS_CLIENTS_OLDEMULE_1, GetResString(IDS_FSTAT_WAITING), 2);
	//m_Stats.AddEntry(STATS_CLIENTS_OLDEMULE_2, GetResString(IDS_FSTAT_WAITING), 2);
	//m_Stats.AddEntry(STATS_CLIENTS_OLDEMULE_3, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_CDONKEY, GetResString(IDS_FSTAT_WAITING), 1);
	//Cax2 - no need to have 3 subcats for that!
	//m_Stats.AddEntry(STATS_CLIENTS_CDONKEY_1, GetResString(IDS_FSTAT_WAITING), 2);
	//m_Stats.AddEntry(STATS_CLIENTS_CDONKEY_2, GetResString(IDS_FSTAT_WAITING), 2);
	//m_Stats.AddEntry(STATS_CLIENTS_CDONKEY_3, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_OLDMLDONKEY, GetResString(IDS_FSTAT_WAITING), 1);
	//Cax2 - no need to have 3 subcats for that!
	//m_Stats.AddEntry(STATS_CLIENTS_OLDMLDONKEY_1, GetResString(IDS_FSTAT_WAITING), 2);
	//m_Stats.AddEntry(STATS_CLIENTS_OLDMLDONKEY_2, GetResString(IDS_FSTAT_WAITING), 2);
	//m_Stats.AddEntry(STATS_CLIENTS_OLDMLDONKEY_3, GetResString(IDS_FSTAT_WAITING), 2);
	m_Stats.AddEntry(STATS_CLIENTS_UNKNOWN, GetResString(IDS_FSTAT_WAITING), 1);

	m_Stats.AddEntry(STATS_QUEUE, GetResString(IDS_QUEUE), 0);
	m_Stats.AddEntry(STATS_QUEUE_TRANSFERRING, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_INQUEUE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_ASKING, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_CONNECTING, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_THRUSERVER, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_GOTHASH, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_NONEEDEDPARTS, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_TOOMANYCONS, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_TWOLOWIDS, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_BLOCKED, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_QUEUE_PROBLEM, GetResString(IDS_FSTAT_WAITING), 1);
	//m_Stats.AddEntry(STATS_QUEUE_UNKNOWN, GetResString(IDS_FSTAT_WAITING), 1);
	
	m_Stats.AddEntry(STATS_SERVERS, GetResString(IDS_FSTAT_SERVERS), 0);
	m_Stats.AddEntry(STATS_SERVERS_WORKING, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SERVERS_BAD, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SERVERS_TOTAL, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SERVERS_DELETED, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SERVERS_WORKINGUSERS, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SERVERS_WORKINGFILES, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SERVERS_TOTALUSERS, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SERVERS_TOTALFILES, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SERVERS_ONSERVER, GetResString(IDS_FSTAT_WAITING), 1);

	m_Stats.AddEntry(STATS_SHAREDFILES, GetResString(IDS_SHAREDFILES), 0);
	m_Stats.AddEntry(STATS_SHAREDFILES_TOTAL, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SHAREDFILES_TOTALSIZE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_SHAREDFILES_AVGSIZE, GetResString(IDS_FSTAT_WAITING), 1);

	m_Stats.AddEntry(STATS_TOTALDOWN, GetResString(IDS_DWTOT), 0);
	m_Stats.AddEntry(STATS_TOTALDOWN_TOTAL, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_TOTALDOWN_TOTALSIZE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_TOTALDOWN_DOWNLOADED, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_TOTALDOWN_LEFT, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_TOTALDOWN_NEEDSPACE, GetResString(IDS_FSTAT_WAITING), 1);
	m_Stats.AddEntry(STATS_TOTALDOWN_SPACELEFT, GetResString(IDS_FSTAT_WAITING), 1);

	// first expand all, then close the ones we don't like :D
	m_Stats.ExpandAllItems();
	CString strExpanded = theApp.glob_prefs->GetStatsListExpanded();
	for(int i = 0; i < strExpanded.GetLength(); i++)
	{
		if(strExpanded.GetAt(i) == '0')		
		{
			switch(i)
			{
				case 0:	 m_Stats.Expand(STATS_TRANSFER, false);					break;
				case 1:  m_Stats.Expand(STATS_TRANSFER_UPLOADS, false);			break;
				case 2:  m_Stats.Expand(STATS_TRANSFER_DOWNLOADS, false);		break;
				case 3:	 m_Stats.Expand(STATS_CONNECTION, false);				break;
				case 4:  m_Stats.Expand(STATS_CLIENTS, false);					break;
				case 5:  m_Stats.Expand(STATS_CLIENTS_EMULE, false);			break;
				case 6:	 m_Stats.Expand(STATS_CLIENTS_EDONKEY, false);			break;
				case 7:  m_Stats.Expand(STATS_CLIENTS_EDONKEYHYBRID, false);	break;
				case 8:	 m_Stats.Expand(STATS_QUEUE, false);					break;
				case 9:	 m_Stats.Expand(STATS_SERVERS, false);					break;
				case 10: m_Stats.Expand(STATS_SHAREDFILES, false);				break;
				case 11: m_Stats.Expand(STATS_TOTALDOWN, false);				break;
				//case 12: m_Stats.Expand(STATS_CLIENTS_CDONKEY, false);			break;
				//case 13: m_Stats.Expand(STATS_CLIENTS_OLDMLDONKEY, false);		break;
				//case 14: m_Stats.Expand(STATS_CLIENTS_OLDEMULE, false);			break;
				default: break;
			}
		}
	}
	m_Stats.SetColumn(theApp.glob_prefs->GetStatsColumnWidth());
	m_Stats.SetRedraw(TRUE);

	EMULE_CATCH
}

void CStatisticsDlg::UpdateActConScale()
{
	EMULE_TRY

	m_Statistics.SetRanges(0, theApp.glob_prefs->GetStatsMax());

	EMULE_CATCH
}
CString CStatisticsDlg::GetStatsListExpanded()
{	
	EMULE_TRY

	CString strExpanded;
	for(int i = 0; i < 12; i++)
	{
		bool bExpanded = false;
		switch(i)
		{
			case 0:	 bExpanded = m_Stats.IsExpanded(STATS_TRANSFER);				break;
			case 1:  bExpanded = m_Stats.IsExpanded(STATS_TRANSFER_UPLOADS);		break;
			case 2:  bExpanded = m_Stats.IsExpanded(STATS_TRANSFER_DOWNLOADS);		break;
			case 3:	 bExpanded = m_Stats.IsExpanded(STATS_CONNECTION);				break;
			case 4:  bExpanded = m_Stats.IsExpanded(STATS_CLIENTS);					break;
			case 5:  bExpanded = m_Stats.IsExpanded(STATS_CLIENTS_EMULE);			break;
			case 6:	 bExpanded = m_Stats.IsExpanded(STATS_CLIENTS_EDONKEY);			break;
			case 7:  bExpanded = m_Stats.IsExpanded(STATS_CLIENTS_EDONKEYHYBRID);	break;
			case 8:	 bExpanded = m_Stats.IsExpanded(STATS_QUEUE);					break;
			case 9:	 bExpanded = m_Stats.IsExpanded(STATS_SERVERS);					break;
			case 10: bExpanded = m_Stats.IsExpanded(STATS_SHAREDFILES);				break;
			case 11: bExpanded = m_Stats.IsExpanded(STATS_TOTALDOWN);				break;
			/*case 12: bExpanded = m_Stats.IsExpanded(STATS_CLIENTS_CDONKEY);			break;
			case 13: bExpanded = m_Stats.IsExpanded(STATS_CLIENTS_OLDMLDONKEY);		break;
			case 14: bExpanded = m_Stats.IsExpanded(STATS_CLIENTS_OLDEMULE);		break;*/
			default: break;
		}
		strExpanded += bExpanded ? '1' : '0';
	}
	
	return strExpanded;

	EMULE_CATCH

	return "";
}

